""" Contains all the data models used in inputs/outputs """

from .assignment import Assignment
from .authorization_perimeter import AuthorizationPerimeter
from .authorization_perimeter_authorizations import AuthorizationPerimeterAuthorizations
from .client_infos import ClientInfos
from .client_infos_headers import ClientInfosHeaders
from .employee import Employee
from .employee_complete import EmployeeComplete
from .employee_infos import EmployeeInfos
from .employee_role import EmployeeRole
from .input_authorization import InputAuthorization
from .input_authorization_operation import InputAuthorizationOperation
from .people_lite import PeopleLite
from .phone_lite import PhoneLite
from .registering import Registering
from .security_credential import SecurityCredential
from .security_credential_extras import SecurityCredentialExtras
from .security_input_authenticate import SecurityInputAuthenticate
from .security_input_delete import SecurityInputDelete
from .security_input_set import SecurityInputSet
from .security_input_set_extras import SecurityInputSetExtras
from .security_outpu_secret import SecurityOutpuSecret
from .security_output_token import SecurityOutputToken
from .server_infos import ServerInfos
from .structure_complete import StructureComplete
from .structure_lite import StructureLite
from .structure_node import StructureNode
from .vpn_group import VpnGroup

__all__ = (
    "Assignment",
    "AuthorizationPerimeter",
    "AuthorizationPerimeterAuthorizations",
    "ClientInfos",
    "ClientInfosHeaders",
    "Employee",
    "EmployeeComplete",
    "EmployeeInfos",
    "EmployeeRole",
    "InputAuthorization",
    "InputAuthorizationOperation",
    "PeopleLite",
    "PhoneLite",
    "Registering",
    "SecurityCredential",
    "SecurityCredentialExtras",
    "SecurityInputAuthenticate",
    "SecurityInputDelete",
    "SecurityInputSet",
    "SecurityInputSetExtras",
    "SecurityOutpuSecret",
    "SecurityOutputToken",
    "ServerInfos",
    "StructureComplete",
    "StructureLite",
    "StructureNode",
    "VpnGroup",
)
