from typing import Any, Dict, Type, TypeVar, Tuple, Optional, BinaryIO, TextIO, TYPE_CHECKING

from typing import List


from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

import datetime
from typing import cast, List
from typing import cast
from ..types import UNSET, Unset
from typing import Union
from dateutil.parser import isoparse






T = TypeVar("T", bound="Assignment")


@_attrs_define
class Assignment:
    """ Description d'une affectation

        Attributes:
            source (Union[Unset, str]): Source de l'information
            start (Union[Unset, datetime.datetime]): Début du contrat
            end (Union[Unset, datetime.datetime]): Fin du contrat
            type (Union[Unset, str]): Type du contrat
            quota (Union[Unset, int]): Quotité de travail (0 si non spécifié
            structure (Union[Unset, str]): Code de la structure d'affectation
            is_main (Union[Unset, bool]): Témoin d'affectation principale
            categories (Union[Unset, List[str]]): Collection de catégories de l'emploi
            is_active (Union[Unset, bool]): Témoin d'activité de l'affectation
     """

    source: Union[Unset, str] = UNSET
    start: Union[Unset, datetime.datetime] = UNSET
    end: Union[Unset, datetime.datetime] = UNSET
    type: Union[Unset, str] = UNSET
    quota: Union[Unset, int] = UNSET
    structure: Union[Unset, str] = UNSET
    is_main: Union[Unset, bool] = UNSET
    categories: Union[Unset, List[str]] = UNSET
    is_active: Union[Unset, bool] = UNSET
    additional_properties: Dict[str, Any] = _attrs_field(init=False, factory=dict)


    def to_dict(self) -> Dict[str, Any]:
        source = self.source

        start: Union[Unset, str] = UNSET
        if not isinstance(self.start, Unset):
            start = self.start.isoformat()

        end: Union[Unset, str] = UNSET
        if not isinstance(self.end, Unset):
            end = self.end.isoformat()

        type = self.type

        quota = self.quota

        structure = self.structure

        is_main = self.is_main

        categories: Union[Unset, List[str]] = UNSET
        if not isinstance(self.categories, Unset):
            categories = self.categories





        is_active = self.is_active


        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({
        })
        if source is not UNSET:
            field_dict["source"] = source
        if start is not UNSET:
            field_dict["start"] = start
        if end is not UNSET:
            field_dict["end"] = end
        if type is not UNSET:
            field_dict["type"] = type
        if quota is not UNSET:
            field_dict["quota"] = quota
        if structure is not UNSET:
            field_dict["structure"] = structure
        if is_main is not UNSET:
            field_dict["isMain"] = is_main
        if categories is not UNSET:
            field_dict["categories"] = categories
        if is_active is not UNSET:
            field_dict["isActive"] = is_active

        return field_dict



    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        if not src_dict:
            return None
        d = src_dict.copy()
        source = d.pop("source", UNSET)

        _start = d.pop("start", UNSET)
        start: Union[Unset, datetime.datetime]
        if isinstance(_start,  Unset) or _start is None:
            start = UNSET
        else:
            start = isoparse(_start)




        _end = d.pop("end", UNSET)
        end: Union[Unset, datetime.datetime]
        if isinstance(_end,  Unset) or _end is None:
            end = UNSET
        else:
            end = isoparse(_end)




        type = d.pop("type", UNSET)

        quota = d.pop("quota", UNSET)

        structure = d.pop("structure", UNSET)

        is_main = d.pop("isMain", UNSET)

        categories = cast(List[str], d.pop("categories", UNSET))


        is_active = d.pop("isActive", UNSET)

        assignment = cls(
            source=source,
            start=start,
            end=end,
            type=type,
            quota=quota,
            structure=structure,
            is_main=is_main,
            categories=categories,
            is_active=is_active,
        )

        assignment.additional_properties = d
        return assignment

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
