from typing import Any, Dict, Type, TypeVar, Tuple, Optional, BinaryIO, TextIO, TYPE_CHECKING

from typing import List


from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

from typing import Dict
from typing import cast
from ..types import UNSET, Unset
from typing import Union

if TYPE_CHECKING:
  from ..models.authorization_perimeter_authorizations import AuthorizationPerimeterAuthorizations





T = TypeVar("T", bound="AuthorizationPerimeter")


@_attrs_define
class AuthorizationPerimeter:
    """ Périmètre d'autorisations

        Attributes:
            description (Union[Unset, str]): Descriptif du périmètre
            authorizations (Union[Unset, AuthorizationPerimeterAuthorizations]): Collection des autorisations liées
     """

    description: Union[Unset, str] = UNSET
    authorizations: Union[Unset, 'AuthorizationPerimeterAuthorizations'] = UNSET
    additional_properties: Dict[str, Any] = _attrs_field(init=False, factory=dict)


    def to_dict(self) -> Dict[str, Any]:
        from ..models.authorization_perimeter_authorizations import AuthorizationPerimeterAuthorizations
        description = self.description

        authorizations: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.authorizations, Unset):
            authorizations = self.authorizations.to_dict()


        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({
        })
        if description is not UNSET:
            field_dict["description"] = description
        if authorizations is not UNSET:
            field_dict["authorizations"] = authorizations

        return field_dict



    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        from ..models.authorization_perimeter_authorizations import AuthorizationPerimeterAuthorizations
        if not src_dict:
            return None
        d = src_dict.copy()
        description = d.pop("description", UNSET)

        _authorizations = d.pop("authorizations", UNSET)
        authorizations: Union[Unset, AuthorizationPerimeterAuthorizations]
        if isinstance(_authorizations,  Unset) or _authorizations is None:
            authorizations = UNSET
        else:
            authorizations = AuthorizationPerimeterAuthorizations.from_dict(_authorizations)




        authorization_perimeter = cls(
            description=description,
            authorizations=authorizations,
        )

        authorization_perimeter.additional_properties = d
        return authorization_perimeter

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
