from typing import Any, Dict, Type, TypeVar, Tuple, Optional, BinaryIO, TextIO, TYPE_CHECKING

from typing import List


from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

from typing import Union
from ..types import UNSET, Unset






T = TypeVar("T", bound="PhoneLite")


@_attrs_define
class PhoneLite:
    """ Description allégée d'un numéro de téléphone

        Attributes:
            human (Union[Unset, str]): Numéro lisible
            standard (Union[Unset, str]): Numéro au format standardisé
            icon (Union[Unset, str]): Icône à utiliser pour l'affichage
     """

    human: Union[Unset, str] = UNSET
    standard: Union[Unset, str] = UNSET
    icon: Union[Unset, str] = UNSET
    additional_properties: Dict[str, Any] = _attrs_field(init=False, factory=dict)


    def to_dict(self) -> Dict[str, Any]:
        human = self.human

        standard = self.standard

        icon = self.icon


        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({
        })
        if human is not UNSET:
            field_dict["human"] = human
        if standard is not UNSET:
            field_dict["standard"] = standard
        if icon is not UNSET:
            field_dict["icon"] = icon

        return field_dict



    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        if not src_dict:
            return None
        d = src_dict.copy()
        human = d.pop("human", UNSET)

        standard = d.pop("standard", UNSET)

        icon = d.pop("icon", UNSET)

        phone_lite = cls(
            human=human,
            standard=standard,
            icon=icon,
        )

        phone_lite.additional_properties = d
        return phone_lite

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
