from typing import Any, Dict, Type, TypeVar, Tuple, Optional, BinaryIO, TextIO, TYPE_CHECKING

from typing import List


from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

from typing import Union
from ..types import UNSET, Unset






T = TypeVar("T", bound="StructureLite")


@_attrs_define
class StructureLite:
    """ Description allégée d'une structure

        Attributes:
            code (Union[Unset, str]): Code entité
            shortname (Union[Unset, str]): Libellé court
            longname (Union[Unset, str]): Libellé long
            displayname (Union[Unset, str]): Libellé complet
            decorator (Union[Unset, str]): Décorateur utilisé pour l'affichage textuel de l'arborescence
            depth (Union[Unset, int]): Profondeur de la structure par rapport à la racine
            is_last (Union[Unset, bool]): Témoin indiquant que la structure est la dernière sur le niveau de la branche
     """

    code: Union[Unset, str] = UNSET
    shortname: Union[Unset, str] = UNSET
    longname: Union[Unset, str] = UNSET
    displayname: Union[Unset, str] = UNSET
    decorator: Union[Unset, str] = UNSET
    depth: Union[Unset, int] = UNSET
    is_last: Union[Unset, bool] = UNSET
    additional_properties: Dict[str, Any] = _attrs_field(init=False, factory=dict)


    def to_dict(self) -> Dict[str, Any]:
        code = self.code

        shortname = self.shortname

        longname = self.longname

        displayname = self.displayname

        decorator = self.decorator

        depth = self.depth

        is_last = self.is_last


        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({
        })
        if code is not UNSET:
            field_dict["code"] = code
        if shortname is not UNSET:
            field_dict["shortname"] = shortname
        if longname is not UNSET:
            field_dict["longname"] = longname
        if displayname is not UNSET:
            field_dict["displayname"] = displayname
        if decorator is not UNSET:
            field_dict["decorator"] = decorator
        if depth is not UNSET:
            field_dict["depth"] = depth
        if is_last is not UNSET:
            field_dict["isLast"] = is_last

        return field_dict



    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        if not src_dict:
            return None
        d = src_dict.copy()
        code = d.pop("code", UNSET)

        shortname = d.pop("shortname", UNSET)

        longname = d.pop("longname", UNSET)

        displayname = d.pop("displayname", UNSET)

        decorator = d.pop("decorator", UNSET)

        depth = d.pop("depth", UNSET)

        is_last = d.pop("isLast", UNSET)

        structure_lite = cls(
            code=code,
            shortname=shortname,
            longname=longname,
            displayname=displayname,
            decorator=decorator,
            depth=depth,
            is_last=is_last,
        )

        structure_lite.additional_properties = d
        return structure_lite

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
