from typing import Any, Dict, Type, TypeVar, Tuple, Optional, BinaryIO, TextIO, TYPE_CHECKING

from typing import List


from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

from typing import Dict
from typing import cast, List
from ..types import UNSET, Unset
from typing import cast
from typing import Union

if TYPE_CHECKING:
  from ..models.structure_lite import StructureLite





T = TypeVar("T", bound="StructureNode")


@_attrs_define
class StructureNode:
    """ Description d'un noeud d'une arborescence de structures

        Attributes:
            structure (Union[Unset, StructureLite]): Description allégée d'une structure
            children (Union[Unset, List['StructureNode']]): Liste de noeuds enfants
     """

    structure: Union[Unset, 'StructureLite'] = UNSET
    children: Union[Unset, List['StructureNode']] = UNSET
    additional_properties: Dict[str, Any] = _attrs_field(init=False, factory=dict)


    def to_dict(self) -> Dict[str, Any]:
        from ..models.structure_lite import StructureLite
        structure: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.structure, Unset):
            structure = self.structure.to_dict()

        children: Union[Unset, List[Dict[str, Any]]] = UNSET
        if not isinstance(self.children, Unset):
            children = []
            for children_item_data in self.children:
                children_item = children_item_data.to_dict()
                children.append(children_item)






        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({
        })
        if structure is not UNSET:
            field_dict["structure"] = structure
        if children is not UNSET:
            field_dict["children"] = children

        return field_dict



    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        from ..models.structure_lite import StructureLite
        if not src_dict:
            return None
        d = src_dict.copy()
        _structure = d.pop("structure", UNSET)
        structure: Union[Unset, StructureLite]
        if isinstance(_structure,  Unset) or _structure is None:
            structure = UNSET
        else:
            structure = StructureLite.from_dict(_structure)




        children = []
        _children = d.pop("children", UNSET)
        for children_item_data in (_children or []):
            children_item = StructureNode.from_dict(children_item_data)



            children.append(children_item)


        structure_node = cls(
            structure=structure,
            children=children,
        )

        structure_node.additional_properties = d
        return structure_node

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
